# StaderLibrary

[Git Source](https://github.com/Ion-Protocol/ion-protocol/blob/88cc595825f1dc2eb738fb93e172a3e8ab7a5c43/src/libraries/lst/StaderLibrary.sol)

A helper library for Stader-related conversions.

### [Functions](broken://pages/sbdPc8M50YEfrj0fH1Wt) <a href="#functions" id="functions"></a>

#### [getEthAmountInForLstAmountOut](broken://pages/sbdPc8M50YEfrj0fH1Wt) <a href="#getethamountinforlstamountout" id="getethamountinforlstamountout"></a>

Returns the amount of ETH needed to mint the given amount of ETHx.

```
function getEthAmountInForLstAmountOut(
    IStaderStakePoolsManager staderDeposit,
    uint256 lstAmount
)
    internal
    view
    returns (uint256);
```

**Parameters**

| Name            | Type                       | Description                   |
| --------------- | -------------------------- | ----------------------------- |
| `staderDeposit` | `IStaderStakePoolsManager` | address.                      |
| `lstAmount`     | `uint256`                  | Desired output amount. \[WAD] |

#### [getLstAmountOutForEthAmountIn](broken://pages/sbdPc8M50YEfrj0fH1Wt) <a href="#getlstamountoutforethamountin" id="getlstamountoutforethamountin"></a>

Returns the amount of ETHx that can be minted with the given amount of ETH.

```
function getLstAmountOutForEthAmountIn(
    IStaderStakePoolsManager staderDeposit,
    uint256 ethAmount
)
    internal
    view
    returns (uint256);
```

**Parameters**

| Name            | Type                       | Description                      |
| --------------- | -------------------------- | -------------------------------- |
| `staderDeposit` | `IStaderStakePoolsManager` | address.                         |
| `ethAmount`     | `uint256`                  | Amount of ETH to deposit. \[WAD] |

#### [depositForLst](broken://pages/sbdPc8M50YEfrj0fH1Wt) <a href="#depositforlst" id="depositforlst"></a>

Deposits ETH into the stader deposit contract and returns the amount of ETHx received.

```
function depositForLst(IStaderStakePoolsManager staderDeposit, uint256 ethAmount) internal returns (uint256);
```

**Parameters**

| Name            | Type                       | Description                      |
| --------------- | -------------------------- | -------------------------------- |
| `staderDeposit` | `IStaderStakePoolsManager` | address.                         |
| `ethAmount`     | `uint256`                  | Amount of ETH to deposit. \[WAD] |

#### [depositForLst](broken://pages/sbdPc8M50YEfrj0fH1Wt) <a href="#depositforlst-1" id="depositforlst-1"></a>

Deposits ETH into the stader deposit contract and returns the amount of ETHx received. This function parameterizes the address to receive the ETHx.

```
function depositForLst(
    IStaderStakePoolsManager staderDeposit,
    uint256 ethAmount,
    address receiver
)
    internal
    returns (uint256);
```

**Parameters**

| Name            | Type                       | Description                      |
| --------------- | -------------------------- | -------------------------------- |
| `staderDeposit` | `IStaderStakePoolsManager` | address.                         |
| `ethAmount`     | `uint256`                  | Amount of ETH to deposit. \[WAD] |
| `receiver`      | `address`                  | to receive the ETHx.             |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ionprotocol.io/devs/smart-contract-architecture/libraries/lst/staderlibrary.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
